// 
// Decompiled by Procyon v0.5.36
// 

package com.justinmind.exportcomments.handlers;

import java.io.File;
import java.util.List;
import com.justinmind.prototyper.api.IPrototype;
import java.io.IOException;
import java.awt.Desktop;
import java.io.Writer;
import java.io.BufferedWriter;
import java.io.FileWriter;
import javafx.stage.Window;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.stage.FileChooser;
import com.justinmind.prototyper.api.comment.IComment;
import com.justinmind.prototyper.api.comment.IRootComment;
import com.justinmind.prototyper.api.API;
import com.justinmind.prototyper.api.plugins.IPlugin;

public class ExportCommentsHandler implements IPlugin
{
    public void run() {
        this.exportToCSV();
    }
    
    protected void exportToCSV() {
        try {
            final IPrototype prototype = API.getPrototypeLoader().loadPrototype();
            if (prototype == null) {
                return;
            }
            final List<IRootComment> comments = (List<IRootComment>)prototype.getApiComments();
            String content = "Author;Date;Comment\n";
            for (final IRootComment iRootComment : comments) {
                content = String.valueOf(content) + this.getCommentTexts((IComment)iRootComment) + "\n";
            }
            final FileChooser dialog = new FileChooser();
            dialog.getExtensionFilters().add(new FileChooser.ExtensionFilter("CSV (*.csv)", new String[] { "*.csv" }));
            final File file = dialog.showSaveDialog((Window)null);
            if (file != null) {
                Writer output = null;
                FileWriter fw = null;
                try {
                    fw = new FileWriter(file);
                    output = new BufferedWriter(fw);
                    output.write(content);
                    output.close();
                    Desktop.getDesktop().open(file);
                }
                catch (IOException e) {
                	Alert a = new Alert(AlertType.ERROR);
                	a.setContentText(e.getLocalizedMessage());
                	a.show();
                }
            }
        }
        catch (Exception e2) {
        	Alert a = new Alert(AlertType.ERROR);
        	a.setContentText(e2.getLocalizedMessage());
        	a.show();
        }
    }
    
    private String getCommentTexts(final IComment comment) {
        String comment_text = "";
        comment_text = String.valueOf(comment_text) + comment.getApiAuthor() + ";";
        comment_text = String.valueOf(comment_text) + comment.getApiDate() + ";";
        comment_text = String.valueOf(comment_text) + comment.getApiContent() + "\n";
        final List<IComment> replies = (List<IComment>)comment.getApiReplies();
        for (final IComment reply : replies) {
            comment_text = String.valueOf(comment_text) + this.getCommentTexts(reply) + "\n";
        }
        return comment_text;
    }
    
    public String getName() {
        return "Export Comments";
    }
}
